(defpackage :gtk-server
  (:use :common-lisp)
  (:export :gtk :gtkserver-init
	   :send-gs-socket :send-gtk :eventp
	   :gtkserver-exit
           :*debug-gtk*
           :*gtk-ffi*
           :*utf8-encode-decode* 

					; GTK Functions Mappings
	   :g_object_unref
	   :g_object_ref_sink
	   :gtk_box_pack_end
	   :gtk_box_pack_start
	   :gtk_button_new
	   :gtk_button_new_with_label
	   :gtk_check_menu_item_new_with_label
	   :gtk_check_menu_item_get_active
	   :gtk_cell_renderer_text_new
	   :gtk_combo_box_new_text
	   :gtk_combo_box_append_text
	   :gtk_combo_box_get_active
	   :gtk_combo_box_get_active_text
	   :gtk_combo_box_remove_text
	   :gtk_combo_box_set_active
	   :gtk_container_add
	   :gtk_dialog_run
	   :gtk_file_chooser_add_filter
	   :gtk_file_chooser_dialog_new
	   :gtk_file_chooser_widget_new
	   :gtk_file_chooser_get_filename
	   :gtk_file_chooser_set_filename
	   :gtk_file_filter_new
	   :gtk_file_filter_add_pattern
	   :gtk_file_filter_set_name
	   :gtk_frame_new
	   :gtk_frame_set_label
	   :gtk_entry_new
	   :gtk_entry_get_text
	   :gtk_entry_set_text
	   :gtk_image_new
	   :gtk_image_new_from_pixmap
	   :gtk_image_new_from_file
	   :gtk_image_set_from_file
	   :gtk_label_new
	   :gtk_label_set_use_markup
	   :gtk_list_store_append
	   :gtk_list_store_iter_is_valid
	   :gtk_list_store_clear
	   :gtk_list_store_new
	   :gtk_list_store_set
	   :gtk_menu_bar_new
	   :gtk_menu_item_new
	   :gtk_menu_item_new_with_label
	   :gtk_menu_item_new_with_mnemonic
	   :gtk_menu_item_set_right_justified
	   :gtk_menu_item_set_submenu
	   :gtk_menu_shell_append
	   :gtk_menu_new
	   :gtk_message_dialog_new
	   :gtk_misc_set_alignment
	   :gtk_hbox_new
           :gtk_hpaned_new
           :gtk_paned_add1
           :gtk_paned_add2
           :gtk_paned_pack1
           :gtk_paned_pack2
           :gtk_rc_parse_string
	   :gtk_scrolled_window_new
	   :gtk_server_enable_c_string_escaping
	   :gtk_table_new
	   :gtk_table_attach_defaults
	   :gtk_text_buffer_get_start_iter
	   :gtk_text_buffer_get_end_iter
           :gtk_text_buffer_get_insert
	   :gtk_text_buffer_get_text
	   :gtk_text_buffer_insert
           :gtk_text_buffer_insert_at_cursor
	   :gtk_text_buffer_set_text
	   :gtk_text_view_get_buffer
	   :gtk_text_view_get_text
	   :gtk_text_view_new
           :gtk_text_view_scroll_to_mark
	   :gtk_text_view_set_text
           :gtk_text_view_set_editable
	   :gtk_tree_model_get_string_from_iter
	   :gtk_tree_selection_set_mode
           :gtk_tree_view_column_get_width
           :gtk_tree_view_column_get_fixed_width
           :gtk_tree_view_column_set_fixed_width
           :gtk_tree_view_column_set_min_width
           :gtk_tree_view_column_get_min_width
           :gtk_tree_view_column_set_max_width
           :gtk_tree_view_column_get_max_width
           :gtk_tree_view_column_set_sizing
           :gtk_tree_view_column_get_sizing
           :gtk_tree_view_get_column
	   :gtk_tree_view_get_selection
	   :gtk_tree_view_new
	   :gtk_tree_view_insert_column_with_attributes
	   :gtk_tree_view_get_model
	   :gtk_tree_view_set_model
	   :gtk_tree_selection_get_selected
	   :gtk_vbox_new 
           :gtk_vpaned_new
	   :gtk_widget_destroy
	   :gtk_widget_show_all
           :gtk_widget_set_size_request
           :gtk_widget_set_name
           :gtk_widget_set_usize
	   :gtk_window_new
	   :gtk_window_set_default_size
           :gtk_window_set_modal
	   :gtk_window_set_title
           :gtk_window_set_transient_for

					; Gui generators
	   :with-components
	   :with-event-loop
	   :with-pack-in
	   :create-component
	   :generatore-text
	   :defcomponent
	   :gui-component
	   :widget

					; Utilities
	   :append-in-menu
	   :with-gtk-server
           :with-guarded-gtk-server
	   :show-info-dialog
	   :show-warning-dialog
	   :show-error-dialog
	   :show-yes-no-dialog
           :show-choose-between

                                        ; Components from the components framework
           :button
           :button-empty
           :combo
           :entry
           :frame
           :hbox
           :image
           :image-f
           :label
           :menu
           :menubar
           :menuitem
           :menuitem-l
           :menuitem-m
           :scrolledwindow
           :table
           :textview
           :vbox
           :window))
